#
#  this is a part of Merlin3 and newnigma2 Image
#
# Coded by Dr.Best (c) 2012
# Support: www.dreambox-tools.info
# E-Mail: dr.best@dreambox-tools.info
#
# This plugin is open source but it is NOT free software.
#
# This plugin may only be distributed to and executed on hardware which
# is licensed by Dream Multimedia GmbH.
# In other words:
# It's NOT allowed to distribute any parts of this plugin or its source code in ANY way
# to hardware which is NOT licensed by Dream Multimedia GmbH.
# It's NOT allowed to execute this plugin and its source code or even parts of it in ANY way
# on hardware which is NOT licensed by Dream Multimedia GmbH.
#
# If you want to use or modify the code or parts of it,
# you have to keep MY license and inform me about the modifications by mail.
#

from Screens.LanguageSelection import LanguageSelection
from Components.Language import language
from Screens.MessageBox import MessageBox
from Tools.Directories import resolveFilename, SCOPE_CURRENT_SKIN, SCOPE_LANGUAGE, fileExists
from Components.Ipkg import IpkgComponent
from Tools.BoundFunction import boundFunction
from Screens.Ipkg import Ipkg
from Components.config import config
from UninstallUnusedLanguages import UninstallUnusedLanguages

baseLanguageSelection__save__ = None
baseLanguageSelection__init__ = None

def LanguageManagerLanguageSelection_Init():
	global baseLanguageSelection__save__, baseLanguageSelection__init__
	if baseLanguageSelection__save__ is None:
		baseLanguageSelection__save__ = LanguageSelection.save
	if baseLanguageSelection__init__ is None:
		baseLanguageSelection__init__ = LanguageSelection.__init__
	LanguageSelection.__init__ = 	LanguageManager__init__
	LanguageSelection.save = LanguageManager_save_
	LanguageSelection.newsave = LanguageManager_newsave
	LanguageSelection.installLanguage = LanguageManager_installLanguage
	LanguageSelection.installLanguageFinished = LanguageManager_installLanguageFinished
	LanguageSelection.checkLanguageInstalled = LanguageManager_checkLanguageInstalled
	LanguageSelection.uninstallLanguageConfirmed = LanguageManager_uninstallLanguageConfirmed
	LanguageSelection.uninstallFinished = LanguageManager_uninstallFinished
	
def LanguageManager__init__(self, session):
	baseLanguageSelection__init__(self, session)
	self.session = session
	self.uninstallLaguages = UninstallUnusedLanguages(self.session, self.uninstallFinished)
	
def LanguageManager_save_(self):
	lang = self["languages"].getCurrent()[0]
	try:
		langlang = language.lang[lang]
	except:
		langlang = None
	if not config.misc.languageselected.value and self.checkLanguageInstalled(langlang):
		self.session.openWithCallback(boundFunction(self.installLanguage,langlang,lang), MessageBox, _("Language %s is not installed.\nDo you want to install it?") % langlang[0])
	else:
		self.newsave(langlang)
		
def LanguageManager_newsave(self, langlang):
	if not config.misc.languageselected.value and langlang:
		self.session.openWithCallback(boundFunction(self.uninstallLanguageConfirmed,langlang), MessageBox, _("Do you want to uninstall all unused languages?"))
	else:
		baseLanguageSelection__save__(self)
		
def LanguageManager_installLanguage(self, langlang, lang, result):
	if result and langlang:
		cmdList= [(IpkgComponent.CMD_UPDATE, {}), (IpkgComponent.CMD_INSTALL, { "package": "enigma2-language-%s" % langlang[1] })]
		self.session.openWithCallback(boundFunction(self.installLanguageFinished,langlang,lang), Ipkg, cmdList = cmdList)

def LanguageManager_installLanguageFinished(self,langlang,lang):
	if self.checkLanguageInstalled(langlang):
		self.session.openWithCallback(self.close, MessageBox, _("Language %s was not installed correctly.\nLanguage will not be changed.") % langlang[0], MessageBox.TYPE_ERROR)
	else:
		self.newsave(langlang)

def LanguageManager_checkLanguageInstalled(self, langlang):
	return langlang and not fileExists(resolveFilename(SCOPE_LANGUAGE, langlang[1] + "/LC_MESSAGES/enigma2.mo"))
		
def LanguageManager_uninstallLanguageConfirmed(self, langlang, result):
	if result:
		self.uninstallLaguages.uninstall(langlang[1])
	else:
		baseLanguageSelection__save__(self)
			
def LanguageManager_uninstallFinished(self):
	baseLanguageSelection__save__(self)
