#
#  this is a part of Merlin3 and newnigma2 Image
#
# Coded by Dr.Best (c) 2012
# Support: www.dreambox-tools.info
# E-Mail: dr.best@dreambox-tools.info
#
# This plugin is open source but it is NOT free software.
#
# This plugin may only be distributed to and executed on hardware which
# is licensed by Dream Multimedia GmbH.
# In other words:
# It's NOT allowed to distribute any parts of this plugin or its source code in ANY way
# to hardware which is NOT licensed by Dream Multimedia GmbH.
# It's NOT allowed to execute this plugin and its source code or even parts of it in ANY way
# on hardware which is NOT licensed by Dream Multimedia GmbH.
#
# If you want to use or modify the code or parts of it,
# you have to keep MY license and inform me about the modifications by mail.
#

from Components.Language import language
from Tools.Directories import resolveFilename, SCOPE_LANGUAGE, fileExists
from Components.Ipkg import IpkgComponent
from Screens.Ipkg import Ipkg

class UninstallUnusedLanguages(object):
	def __init__(self, session, callback = None):
		self.session = session	
		self.callback = callback

	def uninstall(self, activeLanguage):
		cmdList = []
		for x in language.getLanguageList():
			if x[1][1] != activeLanguage and fileExists(resolveFilename(SCOPE_LANGUAGE, x[1][1] + "/LC_MESSAGES/enigma2.mo")):
				cmdList.append((IpkgComponent.CMD_REMOVE, { "autoremove": True, "package": "enigma2-language-%s" % x[1][1] }))
		if cmdList:
			self.session.openWithCallback(self.uninstallFinished, Ipkg, cmdList = cmdList)			
		else:
			if self.callback:
				self.callback()

	def uninstallFinished(self):
		if self.callback:
			self.callback()
